/**
 * @license
 * Copyright (c) 2019 CANDY LINE INC.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=function(l){var u={};var e=function(){Object.keys(u).forEach(function(e){u[e].operations.shutdown()})};process.on("exit",e),l.settings&&l.settings.exitHandlers&&l.settings.exitHandlers.push(e);var d=l.settings.lwm2m||{};(0,_lwm2mCommon.setEmptyValue)(d.emptyValue||"");l.nodes.registerType("lwm2m client",function e(t){var r=this;_classCallCheck(this,e),l.nodes.createNode(this,t),this.disabled=!!t.disabled,this.lazyStart=!!t.lazyStart,this.clientName=t.clientName,this.enableDTLS=!!t.enableDTLS;var n=parseInt(t.clientPort);this.clientPort=isNaN(n)?56830:n,this.lifetimeSec=parseInt(t.lifetimeSec)||300,this.reconnectSec=parseInt(t.reconnectSec)||60,this.bootstrapIntervalSec=parseInt(t.bootstrapIntervalSec)||3600,this.bootstrapIntervalSec<60&&(this.bootstrapIntervalSec=60),this.requestBootstrap=!!t.requestBootstrap,this.saveProvisionedConfig=!!t.saveProvisionedConfig,this.useIPv4=!!t.useIPv4,this.maxRecvPacketSize=t.maxRecvPacketSize||1152,this.redirectLwm2mClientLog=!!t.redirectLwm2mClientLog,this.dumpLwm2mMessages=!!t.dumpLwm2mMessages,this.hideSensitiveInfo=!!t.hideSensitiveInfo,this.propagateInternalEvents=!!t.propagateInternalEvents,this.pskIdentity=(this.credentials||{}).pskIdentity||"",this.presharedKey=(this.credentials||{}).presharedKey||"",this.serverId=parseInt(t.serverId)||99,this.serverHost=t.serverHost,this.serverPort=parseInt(t.serverPort)||(this.enableDTLS?5684:5683),this.objects=t.objects||"",this.secret=l.settings.get("credentialSecret"),this.secret||(this.secret=l.settings.get("_credentialSecret"));var i,o,s,a=(i=this.serverHost,o=this.serverPort,s=this.clientName,i+":"+o+"/"+s);if(u[a])throw Error(l._("lwm2m.error.duplicateEntry",{host:this.serverHost,port:this.serverPort,endpoint:this.clientName}));if(0<Object.keys(u).filter(function(e){return u[e].clientPort===r.clientPort}).length)throw Error(l._("lwm2m.error.duplicateClientPort",{port:this.clientPort,clientName:this.clientName}));(u[a]=this).nodes={};var c=this;!this.disabled&&this.propagateInternalEvents&&d.internalEventBus&&"function"==typeof d.internalEventBus.emit&&(this.internalEventBus=d.internalEventBus,this.setMaxListeners(this.getMaxListeners()+1),this.on("clientStateChanged",function(e){r.internalEventBus.emit("clientStateChanged",e)}),this.on("object-event",function(e){r.internalEventBus.emit("object-event",e)}),0===this.internalEventBus.listenerCount("object-read")&&(this.internalEventBusMaxListeners=this.internalEventBus.getMaxListeners(),this.internalEventBus.setMaxListeners(this.internalEventBusMaxListeners+4),this.internalEventBus.on("object-read",function(){var n=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},e=["object-result"];n.id&&e.push("object-read-"+n.id),r.objectStore.get(n.topic).then(function(t){e.forEach(function(e){r.internalEventBus.emit(e,{id:n.id,type:"object-read",payload:t})})}).catch(function(t){e.forEach(function(e){r.internalEventBus.emit(e,{id:n.id,type:"object-read",payload:t,error:!0})})})}),this.internalEventBus.on("object-write",function(){var n=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},e=["object-result"];n.id&&e.push("object-write-"+n.id),r.objectStore.write(n.topic,n.payload,!1).then(function(){e.forEach(function(e){r.internalEventBus.emit(e,{id:n.id,type:"object-write"})})}).catch(function(t){e.forEach(function(e){r.internalEventBus.emit(e,{id:n.id,type:"object-write",payload:t,error:!0})})})}),this.internalEventBus.on("object-execute",function(){var n=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},e=n.topic||"",t=e.indexOf("/execute");0<=t&&(e=n.topic.substring(0,t));var i=["object-result"];n.id&&i.push("object-execute-"+n.id),r.objectStore.execute(e,n.payload,!1).then(function(){i.forEach(function(e){r.internalEventBus.emit(e,{id:n.id,type:"object-execute"})})}).catch(function(t){i.forEach(function(e){r.internalEventBus.emit(e,{id:n.id,type:"object-execute",payload:t,error:!0})})})}))),this.operations={init:function(){var e=d.objects||{};Array.isArray(e)&&(c.warn("stored objects JSON must be Object rather than Array"),e={}),c.definitions=d.objectDefinitions||{},debug("[init] definitions => "+JSON.stringify(c.definitions));var t={};try{t=JSON.parse(c.objects),Array.isArray(t)&&(c.warn("'Objects' property must be Object rather than Array"),t={})}catch(e){}return new Promise(function(e){return!c.disabled&&c.propagateInternalEvents&&c.internalEventBus?(c.internalEventBus.once("configurationDone",function(t){return c.debug("[configurationDone] config => "+JSON.stringify(t)),t&&t.clientName&&(c.clientName=t.clientName),c.log("ClientName resolved => "+c.clientName),["enableDTLS","clientPort","lifetimeSec","reconnectSec","bootstrapIntervalSec","requestBootstrap","saveProvisionedConfig","useIPv4","redirectLwm2mClientLog","dumpLwm2mMessages","hideSensitiveInfo","pskIdentity","presharedKey","serverId","serverHost","serverPort","credentialFilePath"].forEach(function(e){void 0!==t[e]&&(c[e]=t[e])}),e()}),c.internalEventBus.emit("configure",{clientName:c.clientName})?void c.log("Configuring lwm2m node..."):(c.internalEventBus.removeAllListeners("configurationDone"),c.log("ClientName resolved => "+c.clientName),e())):e()}).then(function(){return c.credentialFilePath=c.credentialFilePath||l.settings.userDir+"/lwm2m_"+encodeURIComponent(c.clientName)+"_cred.json",c.objectStore=new _lwm2mCommon.LwM2MObjectStore(c),c.client=new _lwm2mCommon.LwM2MClientProxy(c),ALL_EVENTS.forEach(function(t){c.client.setMaxListeners(c.client.getMaxListeners()+1),c.client.on(t,function(){try{Object.keys(c.nodes).forEach(function(e){c.nodes[e].emit(t)})}catch(e){c.warn(e)}c.propagateInternalEvents&&c.internalEventBus&&c.internalEventBus.emit(t)})}),new _lwm2mCommon.ResourceRepositoryBuilder([e,t],!0,c.credentialFilePath,c.secret).build(c).then(function(e){c.objectStore.repo=e}).catch(function(e){e instanceof Error&&c.log(e),c.error("lwm2m error",{payload:e})})})},startClient:function(){if(!c.client)throw Error("Not yet initialized!");c.client.isConnected()||c.client.start()},stopClient:function(){if(!c.client)throw Error("Not yet initialized!");c.client.isConnected()&&c.client.shutdown({deregister:!1})},deregisterClient:function(){if(!c.client)throw Error("Not yet initialized!");c.client.isConnected()&&c.client.shutdown({deregister:!0})},register:function(e){return!!e&&!c.nodes[e.id]&&(c.nodes[e.id]=e,c.client&&c.client.isConnected()&&e.emit("connected"),!0)},remove:function(e){return!(!e||!c.nodes[e.id]||(delete c.nodes[e.id],0))},shutdown:function(){return c.propagateInternalEvents&&c.internalEventBus&&(c.internalEventBus.setMaxListeners(c.internalEventBusMaxListeners),["object-read","object-write","object-execute","configurationDone","clientStateChanged"].forEach(function(e){c.internalEventBus.removeAllListeners(e)})),c.client?c.client.shutdown({deregister:!0}):Promise.resolve()}},this.disabled?this.warn("The client ["+this.clientName+"] won't run as disabled."):this.operations.init().then(function(){r.lazyStart?r.log("The client ["+r.clientName+"] will start lazily when 'start' topic message arrives."):r.operations.startClient()}),this.on("close",function(t){delete u[a],r.operations.shutdown().then(function(){t()}).catch(function(e){r.log(e),t()})})},{credentials:{pskIdentity:{type:"text"},presharedKey:{type:"text"}}});l.nodes.registerType("lwm2m client in",function e(t){var i=this;if(_classCallCheck(this,e),l.nodes.createNode(this,t),this.lwm2mClientNodeId=t.lwm2mClient,this.lwm2mClientNode=l.nodes.getNode(this.lwm2mClientNodeId),this.subscribeObjectEvents=!!t.subscribeObjectEvents,this.outputAsObject=!!t.outputAsObject,this.lwm2mClientNode){if(this.subscribeObjectEvents){var n=this.lwm2mClientNode.clientName;this.lwm2mClientNode.setMaxListeners(this.lwm2mClientNode.getMaxListeners()+1),this.lwm2mClientNode.on("object-event",function(e){i.trace("[LwM2MClientIn] <"+n+"> "+JSON.stringify(e)),i.send({payload:e})})}GREEN_EVENTS.forEach(function(t){i.on(t,function(){var e="lwm2m.status."+t;"connected"===t&&i.subscribeObjectEvents&&(e="lwm2m.status.subscribed"),i.status({fill:"green",shape:"dot",text:e})})}),BLUE_EVENTS.forEach(function(e){i.on(e,function(){i.status({fill:"blue",shape:"dot",text:"lwm2m.status."+e})})}),RED_EVENTS.forEach(function(e){i.on(e,function(){i.status({fill:"red",shape:"ring",text:"lwm2m.status."+e})})}),this.lwm2mClientNode.operations.register(this),this.on("input",function(e){if(e&&e.topic)switch(e.topic.toLowerCase()){case"start":return i.lwm2mClientNode.lazyStart?i.lwm2mClientNode.operations.startClient():void 0;case"stop":return i.lwm2mClientNode.operations.stopClient();case"deregister":return i.lwm2mClientNode.operations.deregisterClient()}if(e&&Buffer.isBuffer(e.payload)?i.trace("[LwM2MClientIn] input arrived! msg=> Buffer(length="+e.payload.length+")"):i.trace("[LwM2MClientIn] input arrived! msg=> "+JSON.stringify(e)),i.lwm2mClientNode&&i.lwm2mClientNode.objectStore){var t={topic:e.topic},n=void 0===e.outputAsObject?i.outputAsObject:!!e.outputAsObject;i.lwm2mClientNode.objectStore.get(e.topic).then(function(e){t.payload=e,n&&(t.payload=e.reduce(function(e,t){return e[t.uri]=t.value,e},{})),i.send(t)}).catch(function(e){t.payload=e,i.error("lwm2m error",t)})}}),this.on("close",function(){i.lwm2mClientNode&&i.lwm2mClientNode.operations.remove(i),i.status({})})}this.name=t.name});l.nodes.registerType("lwm2m client out",function e(t){var i=this;_classCallCheck(this,e),l.nodes.createNode(this,t),this.lwm2mClientNodeId=t.lwm2mClient,this.lwm2mClientNode=l.nodes.getNode(this.lwm2mClientNodeId),this.lwm2mClientNode&&(GREEN_EVENTS.forEach(function(e){i.on(e,function(){i.status({fill:"green",shape:"dot",text:"lwm2m.status."+e})})}),BLUE_EVENTS.forEach(function(e){i.on(e,function(){i.status({fill:"blue",shape:"dot",text:"lwm2m.status."+e})})}),RED_EVENTS.forEach(function(e){i.on(e,function(){i.status({fill:"red",shape:"ring",text:"lwm2m.status."+e})})}),this.lwm2mClientNode.operations.register(this),this.on("input",function(e){if(i.lwm2mClientNode){var t=e.topic||"",n=t.indexOf("/execute");(0<=n&&n===t.length-8?i.lwm2mClientNode.objectStore.execute(e.topic.substring(0,n),e.payload,!1):i.lwm2mClientNode.objectStore.write(e.topic,e.payload,!1)).catch(function(e){i.error("lwm2m error",{topic:t,payload:e})})}}),this.on("close",function(){i.lwm2mClientNode&&i.lwm2mClientNode.operations.remove(i),i.status({})})),this.name=t.name})},require("source-map-support/register");var La,_debug=require("debug"),_debug2=(La=_debug)&&La.__esModule?La:{default:La},_lwm2mCommon=require("./lwm2m-common");function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var debug=(0,_debug2.default)("node-red-contrib-lwm2m:lwm2m"),GREEN_EVENTS=["connected"],BLUE_EVENTS=["bootstrapRequired","bootstrapping","registerRequired","registering"],RED_EVENTS=["disconnected","error","timeout"],ALL_EVENTS=GREEN_EVENTS.concat(BLUE_EVENTS).concat(RED_EVENTS);module.exports=exports.default;